Summary: Web Application for LDAP-based user and computer management
Name: dassadmin
Version: @@@VERSION@@@
Release: 1%{?dist}
License: Apache
Group: other
BuildArch: noarch
URL: http://www.dass-it.de/dassadmin

Source: %{name}_%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
%if 0%{?centos_ver} == 6
%define java_package java
%define java_devel_package java-1.6.0-openjdk-devel
%define tomcat_package tomcat6
%define tomcat_dir /var/lib/tomcat6
%define cron_package cronie
%else
%if 0%{?centos_ver} == 7
%define java_package java-1.7.0-openjdk
%define java_devel_package java-1.7.0-openjdk-devel
%define tomcat_package tomcat
%define tomcat_dir /var/lib/tomcat
%define cron_package cronie
%else
%if 0%{?centos_ver} >= 8
%define java_package java-1.11.0-openjdk
%define java_devel_package java-1.11.0-openjdk-devel
%define tomcat_package tomcat
%define tomcat_dir /var/lib/tomcat
%define cron_package cronie
%else
%if 0%{?suse_version} >= 1200
%define java_package java
%define java_devel_package java-devel
%define tomcat_package tomcat
%define tomcat_dir /srv/tomcat
%define cron_package cron
%else
%define java_package java
%define java_devel_package java-devel
%define tomcat_package tomcat6
%define tomcat_dir /srv/tomcat6
%define cron_package cron
%endif
%endif
%endif
%endif

BuildRequires: %{java_devel_package} >= 1.7
BuildRequires: postgresql-jdbc
BuildRequires: %{tomcat_package}
BuildRequires: ant
Requires: %{java_package} >= 1.7
Requires: %{tomcat_package}
Requires: %{cron_package}
Requires: python
Requires: python-ldap
Requires: logrotate
%description
dassadmin is a web application for LDAP-based user and computer management.
It can also manage groups, Samba accounts, mail aliases and devices like printers and switches.
%prep
%setup -n dassadmin

%build
ant jar
%install
export NO_BRP_CHECK_BYTECODE_VERSION=true

mkdir -p "%{buildroot}%{tomcat_dir}/webapps"
mkdir -p "%{buildroot}/opt/dass-it/dassadmin/ldapsync"
mkdir -p "%{buildroot}/etc/init.d"
mkdir -p "%{buildroot}/etc/logrotate.d"
mkdir -p "%{buildroot}/etc/dassadmin"
mkdir -p "%{buildroot}/var/spool/dassadmin"
mkdir -p "%{buildroot}/var/spool/dassadmin/devicetypes"
ant install -Dinstallprefix="%{buildroot}%{tomcat_dir}/webapps/dassadmin"
install -m 755 debian/dassadmin.init %{buildroot}/etc/init.d/dassadmin
install -m 644 debian/dassadmin.logrotate %{buildroot}/etc/logrotate.d/dassadmin
install -m 640 ldapsync/ldapsync.conf.template %{buildroot}/etc/dassadmin/ldapsync.conf
install -m 644 ldapsync/ox2ldap.conf.template %{buildroot}/etc/dassadmin/ox2ldap.conf
install -m 644 ldapsync/groups.blacklist %{buildroot}/etc/dassadmin/groups.blacklist
install -m 644 ldapsync/groups.whitelist %{buildroot}/etc/dassadmin/groups.whitelist
cp -r ldapsync %{buildroot}/opt/dass-it/dassadmin

%clean
%{__rm} -rf %{buildroot}
%post
[ -f /var/spool/dassadmin/lock ] || (echo "1" >/var/spool/dassadmin/lock && chown tomcat:root /var/spool/dassadmin/lock)
%postun
%if 0%{?suse_version}
%insserv_cleanup
%endif
%preun
[ "$1" = 0 ] && rm -f /var/spool/dassadmin/lock
%if 0%{?suse_version}
%stop_on_removal
%endif
%files
%defattr(-,root,root)
%config /etc/init.d/dassadmin
%config /etc/dassadmin/ldapsync.conf
%config /etc/dassadmin/ox2ldap.conf
%config /etc/dassadmin/groups.blacklist
%config /etc/dassadmin/groups.whitelist
%config /etc/logrotate.d/dassadmin
%{tomcat_dir}/webapps/dassadmin
/opt/dass-it/dassadmin/ldapsync
%dir /opt/dass-it/dassadmin
%dir /opt/dass-it
%dir %{tomcat_dir}
%dir %{tomcat_dir}/webapps
%dir /etc/dassadmin
%attr(755,tomcat,root) /var/spool/dassadmin
%changelog
* Thu Oct 24 2013 Sebastian Lederer slederer@dass-it.de 1.0
  - first attempt at an RPM package
