package de.dassit.dassadmin;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class AddressPoolTool {
	static Integer lock = new Integer(0);

	protected String directory;
	protected String prefix;
	protected String subdirectory;

	/**
	 * @return the directory
	 */
	public String getDirectory() {
		return directory;
	}

	/**
	 * @param directory
	 *            the directory to set
	 */
	public void setDirectory(String directory) {
		this.directory = directory;
	}

	/**
	 * @return the prefix
	 */
	public String getPrefix() {
		return prefix;
	}

	/**
	 * @param prefix
	 *            the prefix to set
	 */
	public void setPrefix(String prefix) {
		this.prefix = prefix;
	}

	/**
	 * @return the subdirectory
	 */
	public String getSubdirectory() {
		return subdirectory;
	}

	/**
	 * @param subdirectory
	 *            the subdirectory to set
	 */
	public void setSubdirectory(String subdirectory) {
		this.subdirectory = subdirectory;
	}

	public List<String> getAll() {
		ArrayList<String> result = new ArrayList<String>();

		File dir = getDirectoryFile();
		if (dir == null || dir.exists() == false)
			return result;

		for (File f : dir.listFiles()) {
			if (f.getName().startsWith(prefix)) {
				result.add(f.getName().substring(prefix.length()));
			}
		}
		return result;
	}

	protected File getDirectoryFile() {
		if (subdirectory != null)
			return new File(new File(directory), subdirectory);
		else
			return new File(directory);
	}

	protected File getAddressFile(String a) {
		return new File(getDirectoryFile(), prefix + a);
	}

	public boolean removeAddress(String a) {
		synchronized (lock) {
			File theFile = getAddressFile(a);
			return theFile.delete();
		}
	}

	public boolean isAvailable(String a) {
		File theFile = getAddressFile(a);

		return theFile.exists();
	}

	public static void main(String[] args) {
		AddressPoolTool pool = new AddressPoolTool();
		pool.setDirectory("/tmp");
		pool.setPrefix("mac-");
		pool.setSubdirectory("standort");

		for (String a : pool.getAll()) {
			System.out.println(a);
			System.out.println(pool.isAvailable(a));
			System.out.println(pool.removeAddress(a));
			System.out.println(pool.isAvailable(a));
			System.out.println(pool.removeAddress(a));
		}
	}
}
