package de.dassit.dassadmin;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import javax.naming.directory.SearchResult;

import de.dassit.ldap.Connection;
import de.dassit.ldap.Entry;
import de.dassit.ldap.EntryList;

public class OxResource extends Entry {
	public OxResource() {
		super();
	}

	public OxResource(SearchResult sr) {
		super(sr);
	}

	@Override
	protected EntryList<? extends Entry> getEntryList() {
		return new EntryList<OxResource>() {
			public void addInstance(SearchResult sr) {
				entries.add(new OxResource(sr));
			}
		};
	}

	@Override
	protected void setNamingParameters() {
		setNamingAttribute(defaultNamingAttribute);
		setObjectClasses(new String[] { "top", "inetOrgPerson" });
		setContainer(defaultContainer);
	}

	@Override
	public void setName(String s) {
		super.setName(s);
		setAttribute("sn", s);
	}

	public void setAvailable(boolean flag) {
		setAttribute("employeeType", flag ? "enabled" : "disabled");
	}

	public boolean getAvailable() {
		String s = getAttribute("employeeType");

		return s != null ? s.equals("enabled") : false;
	}

	public List<OxResource> getAll() {
		return search("objectClass=inetOrgPerson", defaultContainer);
	}

	public List<OxResource> search(String filter, String container) {

		EntryList<OxResource> entryList = new EntryList<OxResource>() {
			public void addInstance(SearchResult sr) {
				entries.add(new OxResource(sr));
			}
		};

		Connection.getDefaultConnection().search(filter, container, entryList);
		List<OxResource> result = entryList.getEntries();

		Collections.sort(result, new Comparator<OxResource>() {

			public int compare(OxResource arg0, OxResource arg1) {
				return arg0.getName().compareToIgnoreCase(arg1.getName());
			}
		});

		return entryList.getEntries();
	}
}
