package de.dassit.dassadmin;

import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Random;

public class Shuffler {

	public List<String> shuffle(List<String> l, int seed) {

		Random r = new Random(seed);

		Collections.shuffle(l, r);

		return l;
	}

	public List<String> shuffle(List<String> l) {
		int seed = 42;
		return shuffle(l, seed);
	}

	public String winner(List<String> l, int day) {
		if(day<1 || day>l.size()) {
			return "invalid";
		}
		shuffle(l);
		return l.get(day-1);
	}
	
	public String todaysWinner(List<String> l) {
		Calendar date = new GregorianCalendar();
		int day = date.get(Calendar.DAY_OF_MONTH);
		
		return winner(l,day);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String[] names = { "1", "2", "3", "4", "5", "6" };

		Shuffler shuffler = new Shuffler();
		String w = shuffler.todaysWinner(Arrays.asList(names));
		System.out.println(w);

	}

}
