package de.dassit.ldap;

import java.util.List;

import javax.naming.directory.SearchResult;

public class AccessControlGroup extends GroupOfNames {	
	@Override
	protected EntryList<? extends Entry> getEntryList() {
		return new EntryList<AccessControlGroup>() {
			public void addInstance(SearchResult sr) {
				entries.add(new AccessControlGroup(sr));
			}
		};
	}

	public AccessControlGroup() {
		super();
	}

	public AccessControlGroup(SearchResult sr) {
		super(sr);
	}

	protected void setNamingParameters() {
		setNamingAttribute("cn");
		setObjectClasses(new String[] { "top", "groupOfNames" });
		setContainer(defaultContainer);
	}
	
	public void setOwner(Entry e) {
		put("owner",e.getDN());
	}
	
	public AccessControlGroup getAccessTo(Entry e) {
		if(e == null)
			return null;
		
		List<? extends Entry> result = search("owner=" + e.getDN(), defaultContainer);
		
		if(result != null && result.size()>0)
			return (AccessControlGroup) result.get(0);
		else
			return null;
	}
	
	/*
	 * $access = $acl.getAccessTo($mygroup)
	 * $flag = $access.isAllowed($currentUser)
	 */
	public boolean isAllowed(Entry subject) {		
		return hasMember(subject);
	}

	/*
	 * $flag = $acl.isAllowedFor($mygroup, $currentUser)
	 */
	
	public boolean isAllowedFor(Entry object, Entry subject) {
		AccessControlGroup acl = getAccessTo(object);
		if(acl == null)
			return false;
		else
			return acl.isAllowed(subject);
	}
}
